***************************************************************************
*** Arquivo de rotinas para desenvolvimento de janelas.                 ***
*** -"Rotinas" que animam a abertura e fechamento das janelas           ***
*** Desenvolvido por: Anderson D C - anddcam@yahoo.com                  ***
***************************************************************************

* Abre arquivo de rotina basico para criacao de janelas 3D
set procedure to janelas

***************************************************************************
* "Rotina de abertura de janelas"                                         *
* -------------------------------                                         *
* - Abre janela partindo de um ponto definido por "lini" e "cini" que sao *
* as cordenadas da linha e coluna daonde a janela vai partir.             *
* - Definicao: "do tjan with lini,cini,lfin1,cfin1,lfin2,cfin2"           *
* onde lini,cini sao as coordenadas de inicializacao da abertura e        *
* lfin1,cfin1,lfin2,cfin2 sao as coordenas final da janela.               *
***************************************************************************

procedure tjan
parameters lini,cini,lfin1,cfin1,lfin2,cfin2

z1=(lini-lfin1)/8
y1=(cini-cfin1)/8
z2=(lini-lfin2)/8
y2=(cini-cfin2)/8

lx11=lini-z1
lx12=lini-(z1*2)
lx13=lini-(z1*3)
lx14=lini-(z1*4)
lx15=lini-(z1*5)
lx16=lini-(z1*6)
lx17=lini-(z1*7)

lx21=lini-z2
lx22=lini-(z2*2)
lx23=lini-(z2*3)
lx24=lini-(z2*4)
lx25=lini-(z2*5)
lx26=lini-(z2*6)
lx27=lini-(z2*7)

cx11=cini-y1
cx12=cini-(y1*2)
cx13=cini-(y1*3)
cx14=cini-(y1*4)
cx15=cini-(y1*5)
cx16=cini-(y1*6)
cx17=cini-(y1*7)

cx21=cini-y2
cx22=cini-(y2*2)
cx23=cini-(y2*3)
cx24=cini-(y2*4)
cx25=cini-(y2*5)
cx26=cini-(y2*6)
cx27=cini-(y2*7)

* Variavel responsavel pelo tempo de animacao que varia de uma janela
* a outra, caso esse valor seja elevado, a animacao pode se tornar falha
* ou lenta demais. Caso o computador tenha uma velocidade alta, esse valor
* precisa ser aumentado para melhor visualizacao da animacao e o inverso
* deve ser feito caso o computador seja lento.
*
timec=300
*

save screen to telapp

set color to w+/n

@ lx11,cx11 to lx21,cx21

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx12,cx12,lx22,cx22

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx13,cx13,lx23,cx23

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx14,cx14,lx24,cx24

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx15,cx15,lx25,cx25

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx16,cx16,lx26,cx26

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx17,cx17,lx27,cx27

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lfin1,cfin1,lfin2,cfin2

return

************************************************************
***************************************************************************
* "Rotina de Fechamento de janelas"                                       *
* -------------------------------                                         *
* - Fecha janela partindo dos pontos finais de coordenadas e vai ate o    *
* ponto de partida onde eh especificado em lini e cini.                   *
* - Definicao: "do vjan with lini,cini,lfin1,cfin1,lfin2,cfin2"           *
* onde lini,cini sao as coordenadas de finalizacao do fechamento e        *
* lfin1,cfin1,lfin2,cfin2 sao as coordenas iniciais da janela.            *
***************************************************************************

procedure vjan
parameters lini,cini,lfin1,cfin1,lfin2,cfin2

z1=(lini-lfin1)/8
y1=(cini-cfin1)/8
z2=(lini-lfin2)/8
y2=(cini-cfin2)/8

lx11=lini-z1
lx12=lini-(z1*2)
lx13=lini-(z1*3)
lx14=lini-(z1*4)
lx15=lini-(z1*5)
lx16=lini-(z1*6)
lx17=lini-(z1*7)

lx21=lini-z2
lx22=lini-(z2*2)
lx23=lini-(z2*3)
lx24=lini-(z2*4)
lx25=lini-(z2*5)
lx26=lini-(z2*6)
lx27=lini-(z2*7)

cx11=cini-y1
cx12=cini-(y1*2)
cx13=cini-(y1*3)
cx14=cini-(y1*4)
cx15=cini-(y1*5)
cx16=cini-(y1*6)
cx17=cini-(y1*7)

cx21=cini-y2
cx22=cini-(y2*2)
cx23=cini-(y2*3)
cx24=cini-(y2*4)
cx25=cini-(y2*5)
cx26=cini-(y2*6)
cx27=cini-(y2*7)

* Variavel responsavel pelo tempo de animacao que varia de uma janela
* a outra, caso esse valor seja elevado, a animacao pode se tornar falha
* ou lenta demais. Caso o computador tenha uma velocidade alta, esse valor
* precisa ser aumentado para melhor visualizacao da animacao e o inverso
* deve ser feito caso o computador seja lento.
*
timec=300
*

save screen to telapp

set color to w+/n

@ lx17,cx17 to lx27,cx27
do jan with lx17,cx17,lx27,cx27

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx16,cx16,lx26,cx26

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx15,cx15,lx25,cx25

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx14,cx14,lx24,cx24

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx13,cx13,lx23,cx23

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx12,cx12,lx22,cx22

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

restore screen from telapp
do jan with lx11,cx11,lx21,cx21

xcont=1
do while xcont<timec
   xcont=xcont+1
enddo

return

************************************************************
