***************************************************************************
*** Arquivo de rotinas para desenvolvimento de janelas 3D.              ***
*** -"Rotinas" que criam janelas e botoes.                              ***
*** Desenvolvido por: Anderson D C - anddcam@yahoo.com                  ***
***************************************************************************

***************************************************************************
* "Rotina de criacao de janelas"                                          *
* ------------------------------                                          *
* - Cria janela em formato 3D.                                            *
* - Definicao: "do jan with li1,ci1,li2,ci2                               *
***************************************************************************

procedure jan
parameters li1,ci1,li2,ci2

* Sub-rotina
do jans with li1,ci1,li2,ci2

******************************************************************************
***************************************************************************
* "Rotina de criacao de janelas - Sub-rotina"                             *                                        *
* -------------------------------------------                             *
* - Cria janela em formato 3D.                                            *
* - Definicao: Rotina usada na rotina "Jan"                               *
***************************************************************************

procedure jans
parameters l1,c1,l2,c2

* Funcao para formacao de sombriamento.
sombra(l2,c1+1,l2,c2+1)
sombra(l1,c2,l2,c2+1)

set color to n/w

@ l1,c1 clear to l2,c2

lx1=l1
lx2=l2

do while lx1<=lx2
   set color to w+/w
   @ lx1,c2-1 say ''

   set color to n/w
   @ lx1,c2 say ''

   set color to w+/w
   @ lx1,c1 say ''

   set color to n/w
   @ lx1,c1+1 say ''

   lx1=lx1+1
enddo

cx1=c1
cx2=c2

do while cx1<=cx2-4
   set color to n/w
   @ l2,c1+1 say ''
   @ l2,cx1+2 say ''
   cx1=cx1+1
enddo

cx1=c1
cx2=c2

do while cx1<=cx2-4
   set color to w+/w
   @ l1,c2-1 say ''
   @ l1,cx1+2 say ''
   cx1=cx1+1
enddo

return

***************************************************************************
* "Rotina de criacao de botoes 3D"                                        *
* --------------------------------                                        *
* - Cria Botao em formato 3D.                                             *
* - Definicao: "do botao with l1,c1,l2,c2"                                *
***************************************************************************
procedure botao
parameters lm1,cm1,lm2,cm2

set cursor off

lze=lm1+1
lze2=lze

set color to n/w
@ lm1,cm1 clear to lm2,cm2
@ lm1,cm1+1 to lm2,cm2-1

set color to w+/w

l=lm1+1
do while l<lm2
   @ l,cm1+1 say ''
   l=l+1
enddo

@ lm1,cm1+1 say replicate('',(cm2-cm1)-2)
@ lm1,cm1+1 say ''
@ lm2,cm1+1 say ''

set color to n/w

return

***************************************************************************
* "Rotina para pressionar botoes ou criar profundidades em janelas"       *
* -----------------------------------------------------------------       *
* - Aperta Botao em formato 3D.                                           *
* - Definicao: "do aperta with l1,c1,l2,c2"                               *
***************************************************************************

procedure aperta
parameters l1,c1,l2,c2

set color to w+/w,n+/w

@ l1,c1 to l2,c2

set color to n/w

@ l1,c1 say replicate('',c2-c1)
@ l1,c1 say ''
@ l2,c1 say ''

l=l1+1
do while l<l2

   @ l,c1 say ''
   l=l+1

enddo

return

********************************************************
***************************************************************************
* "Funcao para criacao de sombras"                                        *
* --------------------------------                                        *
* - Cria sombriamento para janelas                                        *
* - Definicao: Utilizado pela rotina "Jans" sub-rotina da rotina "Jan"    *
***************************************************************************

FUNCTION SOMBRA
parameters LS,CS,LI,CI
V=SAVESCREEN(LS+1,CS+1,LI+1,CI+1)
FOR I = 2 TO LEN(V)  STEP 2
 V=STUFF(V,I,1,CHR(8))
NEXT
RESTSCREEN(LS+1,CS+1,LI+1,CI+1,V)
RETURN(1)

